package com.gzlh.device.car.client;

import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ChannelHandler.Sharable
public class CarClientHandler extends SimpleChannelInboundHandler<String> {

    private CarNettyConfig carNettyConfig;

    public CarClientHandler(CarNettyConfig carNettyConfig) {
        this.carNettyConfig = carNettyConfig;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
        log.info("Car 客户端收到消息：" + msg);

    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        log.error("car 客户端 连接断开，进行重连");
        carNettyConfig.connect();
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();
    }

}

