package com.gzlh.device.car.factory;



import com.gzlh.device.car.handler.ICarHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class CarFactory {
    @Autowired
    private List<ICarHandler>handlers;

    public ICarHandler handler(int code){
       return handlers.stream().filter(h->h.brandType().getCode()==code)
                .findAny().orElseThrow(()->new IllegalArgumentException("不支持交互"));
    }

}
