package com.gzlh.device.car.handler.impl;

import cn.hutool.core.util.StrUtil;
import com.gzlh.device.car.action.CarAction;
import com.gzlh.device.car.brand.CarBrandType;
import com.gzlh.device.car.client.CarNettyConfig;
import com.gzlh.device.car.handler.ICarHandler;
import com.gzlh.device.car.utils.RuiDeiPackUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
@Slf4j
public class CarHandlerRuiDei implements ICarHandler {
    @Resource
    CarNettyConfig carNettyConfig;

    @Override
    public CarBrandType brandType() {
        return CarBrandType.SHENZHEN_RUIDEI;
    }

    @Override
    public void sendMsg(String content, String param) {
        log.info("发送电子车牌消息:{}",content);
        String msgHex= RuiDeiPackUtils.build(content,param);
        log.info("数据包:{}",msgHex);
        carNettyConfig.send(msgHex);
    }

    @Override
    public void handlerAction(String action) {
        if (StrUtil.contains(action, CarAction.READ)) {
            sendMsg("","");
        }
    }
}
