package com.gzlh.device.car.utils;

import com.gzlh.utils.WordHandlerUtils;
import com.gzlh.utils.XorUtils;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class RuiDeiPackUtils {
    private static final String bootCode = "40";

    /**
     * 构建
     *
     * @param command       命令
     * @param commandParam  命令参数
     * @return 起始字40 长度(从[命令]到[校验和]最后字节)
     *
     */
    public static String build(String command, String commandParam) {
        //消息的16进制
        String msgHex = WordHandlerUtils.msgToASCII(commandParam);

        String content = command + commandParam;
        int packLength = content.length();
//        计算长度，校验和长度固定为1
        String packLengthHex = Integer.toHexString((packLength / 2) + 1);
        if (packLengthHex.length() == 1) {
            packLengthHex = "0" + packLengthHex;
        }
        //长度->内容
        String dataContent = bootCode + packLengthHex + content;
        String checkSum = checkSum(dataContent);
        String str = dataContent + checkSum;
        System.out.println(str);
        return str;
    }

    public static String checkSum(String dataContent) {
        String checkSum = "";
        byte[] bytes = XorUtils.hexString2Bytes(dataContent);
        byte sum = 0;
        for (byte b : bytes) {
            sum += b;
        }
//        和取补去进位，转为十六进制字符串
        checkSum = String.format("%02x", (~sum + 1 & 0xff)).toUpperCase();
//        System.out.println("TCC-Hex："+checkSum);
        return checkSum;
    }

    public static void main(String[] args) {
        RuiDeiPackUtils.build("FE","");
    }


}
